/**
   Page 366 of the textbook.

   The recurrence relation is
      r(n) = max( p[i] + r[n-i] : with 1 <= i <= n )
*/
class CutRod
{
   public static int cutRod(int[] p, int n)
   {
      if (n == 0)
      {
         return 0;
      }

      int q = Integer.MIN_VALUE;
      for (int i = 1; i <= n; ++i) // i is the position of the first cut
      {
         q = Math.max( q, p[i] + cutRod(p, n-i) );  // recursion
      }
      return q;
   }


   public static void main(String[] args)
   {
      //                   1  2  3  4   5   6   7   8   9  10
      final int[] p = {-1, 1, 5, 8, 9, 10, 17, 17, 20, 24, 30};

      for (int i = 1; i <= 10; ++i)
      {
         System.out.println( "CutRod("+i+") = " + cutRod(p, i) );
      }
   }
}
