/**
   Page 366 of the textbook. (Fixed a bug in line 5 of their code.)

   The recurrence relation is
      r(n) = max( p[i] + r[n-i] : with 1 <= i <= min(n, p.length) )
*/
class CutRod_BottomUp
{
   public static int cutRod(int[] p, int n)
   {
      final int[] r = new int[n+1]; // We will remember the solution values in r.
      r[0] = 0;

      for (int j = 1; j <= n; ++j) // for increasing rod length j
      {
         int q = Integer.MIN_VALUE;
         for (int i = 1; i <= Math.min(j, p.length-1); ++i) // i is the position of the first cut
         {
            q = Math.max( q, p[i] + r[j-i] );  // array look-up (instead of recursion)
         }
         r[j] = q; // Remember the solution value for length j.
      }
      return r[n];
   }


   public static void main(String[] args)
   {
      //                   1  2  3  4   5   6   7   8   9  10
      final int[] p = {-1, 1, 5, 8, 9, 10, 17, 17, 20, 24, 30};

      for (int i = 1; i <= 35; ++i)
      {
         System.out.println( "CutRod_bottom_up("+i+") = " + cutRod(p, i) );
      }
   }
}
