
import java.util.List;
import java.util.ArrayList;

/**
   Compute the actual solution, not the value of the solution.
*/
class CutRod_v3
{
   public static List<Integer> cutRod(int[] p, int n)
   {
      List<Integer> soln = new ArrayList<>();
      if (n == 0)
      {
         return soln;
      }

      for (int i = 1; i <= Math.min(n, p.length-1); ++i) // i is the position of the first cut
      {
         List<Integer> tempSoln = cutRod(p, n-i);  // recursion
         tempSoln.add(0, i);
         if ( value(tempSoln, p) > value(soln, p) )
         {
            soln = tempSoln;
         }
      }
      return soln;
   }

   public static int value(List<Integer> soln, int[] p)
   {
      int value = 0;
      for (Integer i : soln)
      {
         value += p[i];
      }
      return value;
   }


   public static void main(String[] args)
   {
      //                   1  2  3  4   5   6   7   8   9  10
      final int[] p = {-1, 1, 5, 8, 9, 10, 17, 17, 20, 24, 30};

      for (int i = 1; i <= 35; ++i)
      {
         final List<Integer> soln = cutRod(p, i);
         System.out.println( "CutRod("+i+") = " + soln + " with value = " + value(soln, p));
      }
   }
}
